zoukankan      html  css  js  c++  java
  • HDU 4819 Mosaic 二维线段树

    Mosaic

    Time Limit: 1 Sec  

    Memory Limit: 256 MB

    题目连接

    http://acm.hust.edu.cn/vjudge/contest/view.action?cid=95149#problem/G

    Description

    The God of sheep decides to pixelate some pictures (i.e., change them into pictures with mosaic). Here's how he is gonna make it: for each picture, he divides the picture into n x n cells, where each cell is assigned a color value. Then he chooses a cell, and checks the color values in the L x L region whose center is at this specific cell. Assuming the maximum and minimum color values in the region is A and B respectively, he will replace the color value in the chosen cell with floor((A + B) / 2).

    Can you help the God of sheep?

    Input

    The first line contains an integer T (T ≤ 5) indicating the number of test cases. Then T test cases follow.

    Each test case begins with an integer n (5 < n < 800). Then the following n rows describe the picture to pixelate, where each row has n integers representing the original color values. The j-th integer in the i-th row is the color value of cell (i, j) of the picture. Color values are nonnegative integers and will not exceed 1,000,000,000 (10^9).

    After the description of the picture, there is an integer Q (Q ≤ 100000 (10^5)), indicating the number of mosaics.

    Then Q actions follow: the i-th row gives the i-th replacement made by the God of sheep: xi, yi, Li (1 ≤ xi, yi ≤ n, 1 ≤ Li < 10000, Li is odd). This means the God of sheep will change the color value in (xi, yi) (located at row xi and column yi) according to the Li x Li region as described above. For example, an query (2, 3, 3) means changing the color value of the cell at the second row and the third column according to region (1, 2) (1, 3), (1, 4), (2, 2), (2, 3), (2, 4), (3, 2), (3, 3), (3, 4). Notice that if the region is not entirely inside the picture, only cells that are both in the region and the picture are considered.

    Note that the God of sheep will do the replacement one by one in the order given in the input.�
     

    Output

    For each test case, print a line "Case #t:"(without quotes, t means the index of the test case) at the beginning.

    For each action, print the new color value of the updated cell.

    Sample Input

    1 3 1 2 3 4 5 6 7 8 9 5 2 2 1 3 2 3 1 1 3 1 2 3 2 2 3

    Sample Output

    Case #1: 5 6 3 4 6

    HINT

    题意

    给你一个n*n的矩阵,每次操作询问一个区域的(Max+Min)/2是多少

    并且把这个区域的值全部改为(Max+Min)/2这个

    题解:

    二维线段树就好啦

    代码:

    #include <stdio.h>
    #include <string.h>
    #include <iostream>
    #include <algorithm>
    #include <vector>
    #include <queue>
    #include <set>
    #include <map>
    #include <string>
    #include <math.h>
    #include <stdlib.h>
    #include <time.h>
    using namespace std;
    const int INF = 0x3f3f3f3f;
    const int MinN = 1030;
    struct Nodey
    {
        int l,r;
        int Min,Max;
    };
    int locy[MinN],locx[MinN] , n , m, q;
    
    struct Nodex
    {
        int l,r;
        Nodey sty[MinN*4];
        void build(int i,int _l,int _r)
        {
            sty[i].l = _l;
            sty[i].r = _r;
            sty[i].Min = sty[i].Max = 0;
            if(_l == _r)
            {
                locy[_l] = i;
                return;
            }
            int mid = (_l + _r)/2;
            build(i<<1,_l,mid);
            build((i<<1)|1,mid+1,_r);
        }
        int queryMin(int i,int _l,int _r)
        {
            if(sty[i].l == _l && sty[i].r == _r)
                return sty[i].Min;
            int mid = (sty[i].l + sty[i].r)/2;
            if(_r <= mid)return queryMin(i<<1,_l,_r);
            else if(_l > mid)return queryMin((i<<1)|1,_l,_r);
            else return min(queryMin(i<<1,_l,mid) , queryMin((i<<1)|1,mid+1,_r));
        }
        int queryMax(int i,int _l,int _r)
        {
            if(sty[i].l == _l && sty[i].r == _r)
                return sty[i].Max;
            int mid = (sty[i].l + sty[i].r)/2;
            if(_r <= mid)return queryMax(i<<1,_l,_r);
            else if(_l > mid)return queryMax((i<<1)|1,_l,_r);
            else return max(queryMax(i<<1,_l,mid) , queryMax((i<<1)|1,mid+1,_r));
        }
    }stx[MinN*4];
    
    void build(int i,int l,int r)
    {
        stx[i].l = l;
        stx[i].r = r;
        stx[i].build(1,1,1005);
        if(l == r)
        {
            locx[l] = i;
            return;
        }
        int mid = (l+r)/2;
        build(i<<1,l,mid);
        build((i<<1)|1,mid+1,r);
    }
    //修改值
    void Modify(int x,int y,int val)
    {
        int tx = locx[x];
        int ty = locy[y];
        stx[tx].sty[ty].Min = stx[tx].sty[ty].Max = val;
        for(int i = tx;i;i >>= 1)
            for(int j = ty;j;j >>= 1)
            {
                if(i == tx && j == ty)continue;
                if(j == ty)
                {
                    stx[i].sty[j].Min = min(stx[i<<1].sty[j].Min , stx[(i<<1)|1].sty[j].Min);
                    stx[i].sty[j].Max = max(stx[i<<1].sty[j].Max , stx[(i<<1)|1].sty[j].Max);
                }
                else
                {
                    stx[i].sty[j].Min = min(stx[i].sty[j<<1].Min , stx[i].sty[(j<<1)|1].Min);
                    stx[i].sty[j].Max = max(stx[i].sty[j<<1].Max , stx[i].sty[(j<<1)|1].Max);
                }
            }
    }
    int queryMax(int i,int x1,int x2,int y1,int y2)
    {
        if(stx[i].l == x1 && stx[i].r == x2)
            return stx[i].queryMax(1,y1,y2);
        int mid = (stx[i].l + stx[i].r)/2;
       // cout << stx[i].l << " " << stx[i].r << " " << mid << endl;
        if(x2 <= mid)return queryMax(i<<1,x1,x2,y1,y2);
        else if(x1 > mid)return queryMax((i<<1)|1,x1,x2,y1,y2);
        else return max(queryMax(i<<1,x1,mid,y1,y2) , queryMax((i<<1)|1,mid+1,x2,y1,y2));
    }
    int queryMin(int i,int x1,int x2,int y1,int y2)
    {
        if(stx[i].l == x1 && stx[i].r == x2)
            return stx[i].queryMin(1,y1,y2);
        int mid = (stx[i].l + stx[i].r)/2;
       // cout << stx[i].l << " " << stx[i].r << " " << mid << endl;
        if(x2 <= mid)return queryMin(i<<1,x1,x2,y1,y2);
        else if(x1 > mid)return queryMin((i<<1)|1,x1,x2,y1,y2);
        else return min(queryMin(i<<1,x1,mid,y1,y2) , queryMin((i<<1)|1,mid+1,x2,y1,y2));
    }
    
    
    
    int main()
    {
        //freopen("in.txt","r",stdin);
        //freopen("out.txt","w",stdout);
        int T;
        scanf("%d",&T);int m;
        for(int cas = 1;cas <= T;cas++)
        {
            printf("Case #%d:
    ",cas);
            int q;
            scanf("%d",&n);
    
            build(1,1,1005);
            for(int i = 1;i <= n;i++)
                for(int j = 1;j <= n;j++)
                {
                    int a;
                    scanf("%d",&a);
                    Modify(i,j,a);
                }
            int x,y,L;
            scanf("%d",&q);
            while(q--)
            {
                scanf("%d%d%d",&x,&y,&L);
                int x1 = max(x-L/2,1);
                int y1 = max(y-L/2,1);
                int x2 = min(x+L/2,n);
                int y2 = min(y+L/2,n);
                int t = queryMax(1,x1,x2,y1,y2) + queryMin(1,x1,x2,y1,y2);
                //cout<<queryMax(1,x,x2,y,y2) <<" "<< queryMin(1,x,x2,y,y2) << endl;
                t = t/2;
                printf("%d
    ",t);
                Modify(x,y,t);
            }
        }
        return 0;
    }
  • 相关阅读:
    Go语言中的管道(Channel)总结
    Go语言的构建方法总结
    Java里的equals总结
    Cracking the coding interview 第二章问题及解答
    2014年度总结
    一种识别验证码方法的介绍
    由记忆的角度分析我们学习为什么要知其所以然
    pvlan 配置
    f5 数据转发分析
    elasticsearch logstash kibana 研究第一篇
  • 原文地址:https://www.cnblogs.com/qscqesze/p/4877982.html
Copyright © 2011-2022 走看看